% Invariant set computation adapted from the example on the MPT3 page for a
% simple 2D system
% Requires MPT3 toolbox
% ME 234(b), Spring 2022
% Anushri Dixit, Joel Burdick

%%
clear all; close all;
% computes a control invariant set for LTI system x^+ = A*x+B*u
system = LTISystem('A', [1 0;0 1.1], 'B', [1; 0.5]);
system.x.min = [-5; -5];
system.x.max = [5; 5]
InvSet = system.invariantSet()
InvSet.plot('color', 'r')
hold on
% with tighter control constraints
system1 = LTISystem('A', [1 0;0 1.1], 'B', [1; 0.5]);
system1.x.min = [-5; -5];
system1.x.max = [5; 5];
system1.u.min = -1;
system1.u.max = 1;
InvSet = system1.invariantSet()
% invariant = InvSet.H;
% save('invariant_set.mat', 'invariant');
InvSet.plot( 'color', 'b')
xlabel('x_1')
ylabel('x_2')
